# $Id: __init__.py,v 1.10 2011/01/29 23:23:11 edwlan Exp $

import os
import subprocess
import getpass

import emen2.clients.proxy
import emen2.clients.handlers
import emen2.clients.controllers

# Setup some global variables.
# Default EMEN2URI is at the NCMI, but this can easily be set via the environment variable EMEN2URI
__version__ = "$Revision: 1.10 $".split(":")[1][:-1].strip()
USER_AGENT = "emen2client/%s"%__version__
EMEN2URI = os.getenv("EMEN2URI", "http://ncmidb.bcm.edu")


##################################
# Exported utility methods
##################################


# Run a process, get the standard out
def check_output(args, **kwds):
	kwds.setdefault("stdout", subprocess.PIPE)
	kwds.setdefault("stderr", subprocess.STDOUT)
	p = subprocess.Popen(args, **kwds)
	return p.communicate()[0]




def opendb(host=None, username=None, password=None):
	host = host or EMEN2URI
	username = username or raw_input("Username: ")
	password = password or getpass.getpass("Password: ")
	db = emen2.clients.proxy.EMEN2JSONRPCProxy(host=host)
	db._login(username=username, password=password)
	return db



