# $Id: recordtreemodel.py,v 1.7 2010/11/08 09:20:44 irees Exp $
from PyQt4 import QtCore, QtGui, Qt
import collections
import os

import treemodel

# based on PyQt4 example:  examples/itemviews/simpletreemodel

class RecordTreeModel(treemodel.TreeModel):
	def __init__(self, root=None, recnames=None, paths=None, parent=None, recurse=1):
		headers = ["Record Name"]
		self.recurse = recurse
		self.recnames = recnames
		self.root = root
		super(RecordTreeModel, self).__init__(data=paths, headers=headers, parent=parent)


	def setupModelData(self, data, parent=None):

		# ian: much simplified!!!!!
		parents = {}
		parents[str(self.root)] = parent
		stack = [str(self.root)]
		while stack:
			item = stack.pop()
			items = map(str, data.get(item, []))

			# Insert in sorted order
			items = [i[1] for i in sorted( [(self.recnames.get(i,i).lower(), i) for i in items] )]
			
			for i in items:
				treeitem = treemodel.TreeItem([self.recnames.get(i,i), i], parents[item])
				parents[i] = treeitem
				parents[item].appendChild(treeitem)
				stack.append(i)
				


__version__ = "$Revision: 1.7 $".split(":")[1][:-1].strip()
