# $Id: clockthread.py,v 1.5 2010/11/21 04:36:10 irees Exp $
import os
import operator
import Queue
import collections
import time
import datetime

from PyQt4 import QtCore


class ClockThread(QtCore.QThread):
	"""Emit a signal every second with timedelta from start time"""

	signal_tick = QtCore.pyqtSignal(str)

	def __init__(self, starttime=None, parent=None):
		QtCore.QThread.__init__(self, parent=parent)
		self.starttime = starttime
		
	def reset(self):
		self.starttime = time.time()
		
	def run(self):
		self.reset()
		
		while True:
			if self.starttime == None:
				t = ""
			else:
				t = int(time.time() - self.starttime)
				t = str(datetime.timedelta(seconds=t))

			self.signal_tick.emit(t)		
			time.sleep(1)


	@QtCore.pyqtSlot()	
	def longsleep(self):
		print "longsleep"
		self.sleep(5)
__version__ = "$Revision: 1.5 $".split(":")[1][:-1].strip()
