# $Id: jsonrpcresource.py,v 1.33 2011/03/05 00:11:37 irees Exp $
import cgi
import time
import emen2.util.jsonutil

from jsonrpc.server import jsonrpc

# Twisted imports
from twisted.web import server
from twisted.internet import threads
from twisted.web.resource import Resource

# emen2 imports
import emen2.db.config
g = emen2.db.config.g()


import UserDict, collections
collections.Mapping.register(UserDict.DictMixin)


#import emen2.db
#import emen2.util.utils
import emen2.web.responsecodes
import emen2.util.loganalyzer
import emen2.db.record
import emen2.db.recorddef
import emen2.db.paramdef
import emen2.db.user


class e2jsonrpc(jsonrpc):
	typemapping = {
		emen2.db.record.Record: 'record',
		emen2.db.recorddef.RecordDef: 'recorddef',
		emen2.db.paramdef.ParamDef: 'paramdef',
		emen2.db.user.User: 'user',
		set: 'set',
	}
	revmap = dict( (y,x) for x,y in typemapping.iteritems() )

	def create_typemap(self, res):
		result = None
		if isinstance(res, (dict, collections.Mapping)):
			result = self.typemapping.get(type(res)), dict( (k, self.create_typemap(v)) for k,v in res.iteritems() )
		elif type(res) in self.typemapping:
			result = self.typemapping.get(type(res))
		return result



	def _callmethod(self, request, method, kwargs, args, db=None, ctxid=None, host=None, **kw):
		# begin db access
		if method.startswith('_'): raise emen2.web.responsecodes.ForbiddenError, 'Method not Accessible'
		# g.log.msg("LOG_INFO", "====== JSONRPCResource action: method %s ctxid %s host %s"%(method, ctxid, host))
		ctxid = kwargs.pop('ctxid', ctxid)

		# print "method/write", method, db._checkwrite(method)
		db._starttxn(write=db._checkwrite(method))
		g.debug('jsonrpc method', method, args, kwargs)
		with db:
			db._setContext(ctxid,request.getClientIP())
			if method.split('.')[-1] == 'login':
				kwargs['host'] = request.getClientIP()
			methodresult = db._callmethod(method, args, kwargs)
		# end db access
		return methodresult


	def _processresult(self, res, args):
		if args.get('t', False):
			res['type'] = self.create_typemap(res['result'])


	def _logError(self, result, request):
		g.log.msg('LOG_WEB', '%(host)s - - [%(time)s] %(path)s %(response)s %(size)d' % dict(
			host = request.getClientIP(),
			time = time.ctime(),
			path = request.uri,
			response = request.code,
			size = len(result)
		))



__version__ = "$Revision: 1.33 $".split(":")[1][:-1].strip()
