# $Id: group.py,v 1.20 2011/03/05 00:11:37 irees Exp $
# Standard View imports
import emen2.db.config
g = emen2.db.config.g()
from emen2.web.view import View
###


@View.register
class Groups(View):

	@View.add_matcher(r'^/groups/$')
	def multiple(self,q=None):
		self.template="/pages/groups"
		self.title = "Wtf"
		self.title = "Group Directory"
		self.ctxt["q"] = ""
		groups = self.db.getgroup(self.db.getgroupnames())
		admin = self.db.checkadmin()
		self.ctxt["admin"] = admin

		if groups == None:
			self.template="/pages/page"
			self.ctxt["content"]="""No groups found, or insufficient permissions to view group list."""
			return

		self.ctxt["groups"] = groups





@View.register
class Group(View):


	@View.add_matcher(r'^/group/(?P<groupname>[\w\- ]+)/$')
	def main(self, groupname=None):
		group = self.db.getgroup(groupname)
		admin = group.isowner()
		edit = False
		self.ctxt["admin"] = admin
		self.ctxt["edit"] = edit
		self.ctxt["new"] = False
		self.title = "Group: %s"%(groupname)
		self.ctxt["group"] = group
		self.template = "/pages/group"
		
		
	@View.add_matcher(r'^/group/(?P<groupname>[\w\- ]+)/edit/$')
	def edit(self, groupname=None):
		self.main(groupname=groupname)
		self.ctxt["edit"] = True
		
		

	@View.add_matcher(r'^/group/(?P<groupname>[\w\- ]+)/new/$', r'^/groups/new/$')
	def new(self, groupname=None):
		

		admin = self.db.checkadmin()

		if groupname:
			group = self.db.getgroup(groupname)
		else:
			group = self.db.newgroup()

		group.name = "None"

		self.ctxt["admin"] = admin
		self.ctxt["edit"] = True
		self.title = "New Group"
		self.ctxt["group"] = group
		self.ctxt["new"] = True
		self.template = "/pages/group"
__version__ = "$Revision: 1.20 $".split(":")[1][:-1].strip()
